from typing import Any, Dict
from geniusweb.issuevalue.Value import Value

class Bid:
    def __init__(self, issuevalues:Dict[str, Value]):
        '''
        FIXME use strict typing
        '''
        self._issuevalues = issuevalues;

    def getIssueValues(self) -> Dict[str, Value]:
        return self._issuevalues
    
    def getIssues(self):
        return self._issuevalues.keys()
    
    
    def getValue(self, issue:str) -> Value :
        '''
        @param issue name of the issue
        @return the value for the given issue, or null if there is no value for
                the given issue.
        '''
        return self._issuevalues[issue];
    
    def __eq__(self, other):
        return isinstance(other, self.__class__) and \
            self._issuevalues == other._issuevalues

    def __str__(self) -> str:
        return "Bid" + str( self._issuevalues);