from decimal import Decimal
from typing import List
from immutablelist.ImmutableList import ImmutableList

class Range(ImmutableList[Decimal]):
    def __init__(self, low:Decimal, high: Decimal, step:Decimal):
        self._low=low
        self._high=high
        self._step=step
        
    def getLow(self):
        return self._low
    
    def getHigh(self):
        return self._high
    
    def getStep(self):
        return self._step
    
    def get(self, index:int)-> Decimal:
        return self._low+ self._step  * index
    
    def size(self) -> int:
        if self._low > self._high:
            return 0
        n = int( (self._high - self._low) / self._step)
        return n+1
    
    def __iter__(self):
        raise NotImplemented
    
    def __eq__(self, other)->bool:
        return isinstance(other, self.__class__) and \
             self._low == other._low and \
             self._high == other._high and\
             self._step == other._step

    def __str__(self):
        return "Range["+self._low+","+self._high+","+self._step+"]"