import sys
import json
import logging
from typing import cast
 
from geniusweb.party.DefaultParty import DefaultParty
from geniusweb.party.Capabilities import Capabilities
from geniusweb.inform.Inform import Inform
from geniusweb.actions.EndNegotiation import EndNegotiation
from geniusweb.actions.PartyId import PartyId
 
class EmptyParty (DefaultParty):
    """
    A empty party just for testing PartyStdio.
    """
    def __init__(self):
        super().__init__()
        self.getReporter().log(logging.INFO,"party is initialized")
        self._lastReceivedBid:Bid = None
        self.received=[]

    # Override
    def notifyChange(self, info: Inform):
        self.getReporter().log(logging.INFO,"received info:"+str(info))
        self.received.append(info)
        self.send(EndNegotiation(PartyId('someone')))

    # Override
    def getCapabilities(self): # -> Capabilities
        return Capabilities( set([ "SAOP"]), set(['geniusweb.profile.utilityspace.LinearAdditive']))

    # Override
    def getDescription(self):
        return "test description"

    # Override
    def terminate(self):
        super().terminate()

